1.1.0.1 
	- Змінено логіку налаштування
	- Виправлення зміни налаштування каси пРРО у iiko
1.1.1.7
	- Додано систему бекапів в google API Drive
1.1.2.1
	- Додано перевірку наявності коду УКТЗЕД для страви з довіднику, або (поки немає оновлення айко)
	з поля у картці товару  "Опис на іноземній мові".
1.1.2.5
	- Додано налаштування стандартного податку
1.1.2.6 
	- Виправлено помилку IProduct with id 00000000-0000-0000-0000-000000000000 not found при 
	предоплаті яка була додана у версії 1.1.2.1. Тоді забув вимкнути рядок дебагу
1.1.2.7
	- Збільшено таймаут очікування відповіді сервера ДПС до 40 секунд, (для пінгів стандартні 10 сек)
1.1.2.8
	- Після кожного успішно переданого чеку у режимі офлайн записується його хеш у базу як offlineHash
	- Відключено бекапер GoogleDrive API
	- Виділено ping у окремий метод з можливістю рекурсивного виклику 
	у випадку деяких помилок від серверу ДПС (badHash, wrongOfflineId).
	- Логіку передачі офлайн чеків виділено у окремий метод 
1.1.3.1
	- Додано бекап Z-звітів на сервер
	- Обновив деякі бібліотеки плагіна і оптимізував збірку. Плагін сильно "схуд"
1.1.3.2
	- Поправлено логіку додавання УКТЗЕД коду для 7.3.6, там при пустому "описі на іноземній мові" айка вертала null,
	що спричиняло помилку
1.1.3.3
	- Зміна логіки виставлення і перевірки статусу пРРО.
1.1.3.4
	- Оптимізація записів логування бекапів і відкриття каси
1.1.3.5
	- Виправлено пінгування сервера і обробку виключень ErrorOfflineId
1.1.3.6
	- Виправлено баг з пустим полем назви страви за певних умов
1.1.3.7
	- Поправлено шаблон чеку, виділено кожен вид податку у окремий рядок
1.1.3.8
	- Зміна до 50 мінімальної кількості офлайн ід необхідних для запиту OfflineIds
1.1.3.9
	- У регулярний вираз пошуку коду УКТЗЕД (по іноземному опису) перевірку на пробільні символи і # 
1.1.3.10
	- Додано перевірку на офлайн режим при запиті офлайн ід чеків
1.2.1.1
	- Відредаговано xml (додано нові поля), додано зчитування акцизних марок, змінено запити згідно нового протоколу ДФС 
	- Скорочено час першого налаштування пристрою методом попередньої ініціалізації бібліотеки бд
	- Код УКТЗЕД парсить з назви у окреме поле, з поля "Опис на іноземній мові", або з поля ТНЗЕД (майбутні версії). 
	- Відредаговано друковану форму чека під додаткові вимоги.
	- Додано окрему базу акцизних марок. Потенційно при необхідності можливо сформувати звіт по проданих марках на пРРО.
	- Додано ланцюг SSL сертифікатів у збірку плагіна
1.2.1.5
	- Внесено зміни в протокол, чеки з черги до 01.10 на старий RPC.
1.2.1.6
	- Протестував механізм перевірки давності перебування у офлайн режимі при відритті зміни
	- Поправив регулярні вирази під особливості C# щоб адекватніше розпізнавало прокатану акцизну марку, відключив тестове розпізнавання прокатаних карт
	- Зробив примусовий запит офлайн ід чеків з режиму офлайн коли їх кількість 0.
1.2.1.7
	- При ErrorType пінгу додано перевірку на предмет наявності офлайн id з автоматичним запитом OfflineIds. 
	- Поправлено видалення коду УКТЗЕД щоб у назві страви не залишалось пробіла якащо він був після коду.
1.3.1.1
	- Додано систему автооновлення плагіна. 
	- Перейменовано кнопки архівації звітів, перевірки звязку з ДПС
	- Додав подію збірки для автовидалення файлів FrontSDK з вихідного каталогу
1.3.1.3
	- Додано можливість вибору принтера (тестовий варіант)
1.3.1.4
	- Розділення ПДВ і акцизного збору у Z-звіті
	- Зведено цифри у чеках оплати, внесень, звітах до одного формату #.##
	- Поправлено друк копії Z-звіту
1.3.1.5
	- Знято обмеження на внесення сум з копійками (1-9 коп)
1.3.1.6
	- Прибрано читання "ШК" з сканованого QR акцизної марки
	- Виправлена ціна товару у паперовому чеку, могла бути 0.00
1.3.1.7
	- Виправлено ліцензування
	- Отримання предоплат винесено у окрему функцію з рефлексією
1.3.1.8
	- Зробив обробку зміни касира при пінгах, з вимогою закрити касу.
	- Додав needSessionClose і pingIsPossible.
	- Сповіщення у ватчдогу про закінчення ключа
	- ErrorNotRegisteredSignerException не падає при пінгу, просто зупинка пРРО
1.3.1.9
	- Змінено поведінку пРРО при запиті OfflineIds і виключенні ErrorOfflineId
	- Прибрав надлишкове логування автооновлення
1.3.1.10
	- ОБробка відповіді ErrorType виправлено (пропуск файлу з черги), додано перевірку на BadHash у цьому статусі
	- Прибрано з коду перевірку і перетворення на старий протокол (до 01.10)
1.3.1.11
	- Виправлено помилку у GetPrepaymentFromCheque (<)
1.3.1.12
	- Збільшено таймаут завантаження оновлення до 2 годин
	- Виправлено баг з видаленими стравами з замовлення і акцизною маркою
	- Виправлено перевірку на штрихкод пляшки при скануванні

1.3.1.14 (24.12.2021)
	- Якщо чергу передачі пропускає файл тоді не записує його хеш (need_miss_doc)
	- У getOfflineIds виправлено повторне присвоєення підписаного файлу при виключенні ErrorOfflineIdException
	- Обробку акцизних марок винесено у ProccessExciseStumps() // переглянути логіку
1.3.1.15 (06.01.2022)
	- Змінено обробку виключеняня BadHashException, читання з виключення нової хеш-суми.
	- Якщо хеш попереднього повідомлення в черзі передачі рівний поточному хешу - документ пропускає
	- Прибрав помилковий код після не публічної 1.3.1.14 з початку функції Ping();
	- Оптимізація отримання хешу останнього чеку з сервера. Такі запити зведено на мінімум.
	- Якщо закінчились ід офлайн чеків у режимі офлайн - перехід в онлайн і отримання ід
1.3.1.16 (06-07.01.2022)
	- Додано виключення для предоплати без ставки
	- Додав у логування хешсуму xml
	- Ping більше не шлеться з offline id, у випадку виключення ErrorOfflineId пінг вважається успішним (економія оффлайн ід чеків).
	- В функції передачі черги офлайн оптимізував розрахунки хеш сум і додав логування на кожному етапі 
	- В функції передачі черги офлайн при помилковому офлайн id зробив присвоєнння newHashForNextPacket.
	- В функції передачі черги офлайн при зробив присвоєнння newHashForNextPacket якщо вимагається його зміна
	- Правки шаблону чеку з форматом цифр #.##
	- Додав логування пропуску файла з черги
	- Додав зберігання оновленого XML у базу Queue після оновлення OfflineId або MAC або при помилці.
1.3.1.17 (08.01.2022)
	- Додав перевірку поточного MAC документу з черги з HashSum попередньо переданого чеку. 
1.3.1.18 (09.01.2022)
	- При запиті оффлайн ід чеків додано перевірку чи ід вже є в базі і чи використовується в ланцюжку офлайн чеків
1.3.1.19 (10.01.2022)
	- У запит getOfflineIds додано обмеження, не питати ід якщо ми в офлайні, і якщо  
1.3.1.20
	- Додано перехоплення виключення ErrorVerefyException при передачі документів з черги офлайн (Таймуат пеервырки підпису).
1.3.1.21
	- Скорочено час пінгу сервера ДФС до 2хв.
1.3.1.22
	- Відредаговано перевірку на мінімальні кількості офлайн чеків при операціях з касою (checkPrroRestriction)
	- Зробив перевірку офлайн ід в онлайні після пінгу, за умови не відправки даних з черги 
1.3.1.23
	- Додано перехоплення виключення ErrorSaveException (incorect hash) при передачі даних з офлайн черги, без обробки поки.
1.3.1.24
	- При зміні офлайн ід у xml і його збереженні, міняється також і ід в SQL.
1.3.1.25
	- Обробка виключення при ErrorXmlChkException і not correct MAC ID (не збігаються офлайн ід у чеку і запиті).
1.3.1.26
	- Зменшено час пінгу при старті до 3 секунд.
	- Перехоплення виключення ErrorSaveException обробляє "incorrect hash" заміною дати.
1.3.1.27 (11.01.2022)
	- Видалення всіх офлайн ід перед записом
	- У випадку коли офлайн ід закінчились в процесі передачі - пРРО перейде в онлайн і запитає їх сам.
1.3.1.28 (12.01.2022)
	- Тимчасово встановлено таймаут для пінгів - 20 секунд, тест
1.3.1.29 (15.01.2022)
	- GetOrderById замінено на TryGetOrderById, на випадок якщо замовлення не знайдено по id.
1.3.1.30
	- При внесенні/вилученні додано перевірку по базі чи зміна відкрита, якщо ні - виключення.
	- Додано обробку ErrorUnknownException у пінгах, коли ФН не активний у ДФС
2.1.1.1
	- Змінено byte на int для DAT NC у моделі Z-звіту. Виправить помилку друку копії чи періодичного звіту з кількістю чеків за зміну більшим 255
	- Змінено виключення
	- Методи принтера і генератора шаблонів винесено у окремі класи
	- Додано клас обгортку для підписувння чеків
	- Перейменовано інкасацію коштів і внесення на чеку
	- Інформація з рядком продажу пернесена після УКТЗЕД і акцизної марки у шаблоні чеку
2.1.2.1
	- У конфігуратор пРРО додано можливість редагувати дані ключа
	- Додано таблицю LastKeyInfo для зберігання даних про підписанта
	- Додано перевірку ключа
2.1.2.2
	- Змінено умови присвоєння needToOfflineCreate - для додавання в ланцюжок документу переходу в офлайн.
2.1.2.3
	- Видалено блок finally з методу CheckPingAndTrySendAsync який спричиняв конфлікт виставляння змінної pingInProccess
2.1.2.4
	- Виправлено перенесення файлів з стврої черги у нову таблицю
2.1.2.5
	- Додано видалення таблиць які не використовуються (Documents_queue і Sent_queue) та очистку по часу таблиць чеків і відправлених документів. 
2.1.2.6
	- В моделі даних Z-звіту для NO змінено тип даних з byte на ushort.
	- Додано у логуванні дані для якого ФН періодичний звіт і який звіт парситься
	- Додано логування стану блокування потоку перед чеком
2.1.2.7
	- Додано функцію перевірки MAC останнього чеку у таблиці (CheckLastHashSumInDb).
	- Рівень логування змінено для проблем підписування даних.
2.1.2.8
	- У метод checkPrroRestriction при перевірці обмеження 36годин додано перевірку чи пРРО офлайн.
	- Додано логування часу переходу в офлайн при спрацюванні обмеження 36 годин.
	- Додано обнулення дати переходу в офлайн при виході з офлайну.
2.1.2.9
	- Дефолтний податок виставляється без запиту у інтерфейсі iikoFront
2.1.3.1
	- Додано таблицю LastKeyInfo і додані перевірки на тривалість дії ключа і обмеження на відкриття каси за 36 годин до завершення терміну дії ключа.
	- Змінено CheckPrroRestriction, тепер в параметри передаєтсья тип операції.
2.1.3.2
	- Додано редагування таблиці LastKeyInfo при зміні ключа підпису на старті пРРО.
	- Прибрав властивість errorMessage із RequestTaxResult, і додано член operationException (тип операції), і додано перевірку на наявність опису виключення.
2.1.3.3
	- Додано циклічну зміну хешсум документів у черзі у випадку несходження ланцюжку повідомлень
2.1.3.4
	- Додав логування стектрейсу при виключенні на підписі документу
	- пРРО конфігуратор тепер при запуску виводиться поверх поточного вікна.
2.1.4.1
	- Об'єкт блокування потоків (threadLock) тепер не статичний.
	- Додано блокування потоку (threadLock) при перевірці кількості офлайн документів після передачі документу і додаванні документу toOnline.
	- В методі DoSignAsync для Task тип значення яке повертається спрощено.
	- Змінено логіку перевірки чи вказано дефолтний податок. Якщо ні тоді не проходити в циклі рядки чеку.
	- Додано контроль ід дефолтного податку на максимальне можливе значення податкової ставки по БД.
2.1.4.5
	- У метод обробки виключень надсилання документів (ExceptionHandle) додано обробку не вірної хешсуми 
	попереднього чеку при відправці документів.
	- У ExceptionHandlerBase і у наслідуваних ним класів в конструктор тепер передається DocumentHandler.
	- Добавлено об'єкт-locker потоку для методу додавання документу в бд (AcceptDocumentToHandle).
2.1.4.6
	- Додано блокування об'єкта блокування запису в базу (queueLocker) на час очистки/додавання OfflineIds. 
2.1.4.7
	- Додано логування повідомлення від ДФС у HandleErrorTypeException
2.1.4.8
	- Додано логування xml при невдалому пінгу HandleErrorTypeException
	- Додано запис xml документу в об'єкт TaxRequestData.
	- Додано інкрементацію лічильника помилок ErrorType для пінгу, при 50+ помилок - вважається критичною помилкою.
	- Виправлено логіку зміни даних ключа підпису у БД при зміні існуючого запису.
	- Якщо MAC у базі пустий - попередньо додати у базу OfflineIds, а тоді надсилання OfflineIds в метод перевірки звязку до пінгу.
2.1.4.9
	- Додано логування інформації яким ключем здійснюється підпис у метод DoSignAsync. За межами асунхронного коду
	- Прибрано логування про початок операції підпису у методі відправки документу з черги.
2.1.4.10
	- Примусово вимкнено запит міток TSP при підписі документів.
2.1.4.11
	- Увімкнено запит міток TSP при підписі документів.
2.1.4.12
	- Для першого запуску пРРО при створенні документу отримання OfflineIds додано перевірку чи не пуста черга. 
	- У випадку не успішної передачі першого документу отримання OfflineIds виправлено "звільнення" pingInProccess.
2.1.4.14
	- Змінено механізм додавання документу отримання офлайн ід чеків при першому пінгу.
	- При записі офлайн ід прибрано видалення офлайн ід які присутні уже в черзі.
2.1.4.16
	- Додано сповіщуючі діалоги про наближення закінчення ключа при відкритті і закриті касових змін (172год).
2.1.4.17
	- При ErrorType у методі пінгу для отримання pRROInfo використано FirstOrDefault() замість Single();
	- Правка у методі PingAsync().
	- У пінгу при перехопленні виключення перевіряється чи є внутрішнє виключення і логується.
	- У методі PingAsync виправлено звернення до видаленої таблиці черги документів
2.1.4.18
	- Закоментовано cancelTokenSource.Dispose().
2.1.4.20
	- Додано зміну DI при додаванні попереду черги документ toOffline.
	- При записі офлайн ід добавлено перевірку які офлайн ід уже присвоєні документам у черзі, їх видаляє.
	- Прибрано інкримент номеру DI у методі оплати чеку. Він дублював операцію у методі додавання документу в чергу.
	- При ErrorOfflineIdException не буде потворної спроби відправки документу. Вважається критичною помилкою.
2.1.4.21
	- Якщо не вибрано ключ (чи інше виключення у конструкторі DocHandler) пристрій тепер запускається у статусі "Зупинено", а не падає. 
	- Додано обробка виключення над конструктором DocHandler і у методі Start перевірка чи DocHandler не null.
2.1.4.23
	- Додано обробку виключення ErrorCheckException (there can be only one signatory within a shift), при пінгу не вважати критичним і перейти до передачі. 
2.1.4.25
	- Виправлено помилку з записом у бд мінімальної дати переходу у офлайн.
	- Виправлено обнулення часу переходу в офлайн при поверненні в онлайн.
2.1.4.26
	- Розділено методи IsCodeInName і IsCodeInString щоб коректніше парсити назви страв тільки з цифрами на наявність УКТЗЕД
2.1.4.27
	- Виправлено реакцію пРРО на невірний офлайн ід при пінгу.
2.1.4.28
	- Додано запобіжник на перевірку суми у касі при вилученні.
2.1.4.30
	- Виключення ErrorCheckException "shift is already open" вважаєтся критичним і зупинить роботу пРРО.
2.1.4.31
	- Виключення ErrorSaveException "incorrect hash" вважається критичним.
	- Виключення ErrorUnknownException "Exceeded number of errors" вважається критичним.
2.1.5.1
	- Додано розділення по сумах податків у копіях z-звітів і періодичних звітах. 
2.1.6.1
	- Адаптація під Syrve 8.1.3. В totalIncomeSum плагін тепер повертає суму без урахування внесень-вилучень.
	- Виправлення помилки "Не вірна очікувана сума" при внесенні / вилученні готівки.
	- Додано кнопку обходу тимчасової помилки "NotRegisteredSigner" (не відтестовано).
	- Додано перевірку на суму вилучення у плагіні.
2.1.6.5
	- GetPrroInfoAsync() при старті обгорнуто в try\catch
2.1.6.12
	- Додано нові виключення підпису і їх обробки.
2.1.6.14
	- Видалено шматок дубльованого коду який відповідає за скасування (через CancellationToken) поточного запиту якщо він в процесі
2.1.6.15
	- На чеку друк ІД чи ПН в залежності від довжини ідентифікатора (ІПН/ЄДРПОУ)
2.1.6.17
	- Виправлено можливість невиходу з режиму ігнорування 36 годин офлайну.
	- Виправлено потенційне не збереження даних у делегаті в SetChangesToDb
2.1.7.1
	- Якщо при передачі офлайн документу критична помилка - відбудеться зупинка пРРО.
	- Додано обробник incorrect hash шляхом зміни дати формування XML у файлах до передачі.
2.1.7.2
	- "this key opens a shift on another device fn" тепер критична 
2.1.7.3
	- Додано логування чи включний ігнорування ліміту OfflineTime.
	- HandleErrorSaveBadTimeFormationException міняє дату документів тільки за умови що на сервері ДФС у останньому документі більш нова дата.
2.1.7.4
	- Для методу getFakeFiscalResult() виправлено поверення суми актуальної готівки, без повторних операцій з внесеннями вилученнями.
2.1.7.6
	- Час обмеження відкриття каси при закінченні ключа зменшено до 24 годин (з 36 годин).
	- Додано кнопку обходження ліміту при закінченні ключа менше ніж за 24 години.
2.1.7.7
	- Правки ігнорування помилки ДФС - незареєстрований касир
2.2.1.1
	- Додано колонки AdditionalFeeReturnSum і BasicTaxReturnSum для таблиці Taxes_Circulation.
	- Додано атрибути SMO, TXO, DTO для тегу TXS Z-звіту.
	- Змінено логіку врахування повернення у z-звітах.
	- Виправлено AdditionalFeePercent на AdditionalFeeSum у розрахунку бази нарахування ПДВ для z-звіту.
	- Правки у друкованій формі Z-звіту
2.2.3.1
	- Зміни у ДФС, тепер список офлайн ід чеків приходять не підписані. Зміни у методі WriteOfflineIds(). (08.09.2022)
2.2.4.3
	- WriteOfflineIds() переписано під варіант коли ДФС вертає і підписані дані і не підписані як було і зараз є на тестовому сервері. 
	- Зроблено обробку виключень читання підпису ДФС.
2.2.5.1
	- Якщо при пінгу з пустим MAC ID помилка ErrorType вважається нормою. 
2.2.5.3
	- У шаблоні чеку внесення/вилучення і періодичного звіту два теги Tags.Doc, що викликало лише логування помилки. Зайвий тег видалено.
2.2.5.4
	- При зміні налаштувань пРРО виправлено непотрібну спробу редагування FN у бд пРРО.
2.2.5.5
	При завершенні методу пінгування безумовне редагування змінної pingInProccess.
2.2.5.7
	- Зміна у схемі призначення текстового статусу пРРО при відповіді ДФС з помилкою.
2.2.5.8
	- Таймаут пінгу задано 20 секунд.
2.2.5.9
	-  Таймаут пінгу повернуто 10 секунд.
2.2.5.10
	- У HandleHashDifferenceInQueue() при циклічній зміні хешсуми у бд збереження відбувається тільки один раз.
2.2.5.11
	- "Оборот" замінено на "Обіг" у друкованих документах.
2.2.5.12
	- Додано перевірку на тривалість ключа на випадок продовження терміну дії ключа без його зміни.
2.2.5.14
	- Додано обробку помилки ініціалізатора бібліотеки підпису при битому файлі ospus.ini.
2.2.6.1
	- Зміни у шаблоні з-звіту. База нарахування ПДВ має друкуватись тільки при не нульовому ПДВ.
2.2.6.2
	- Додано запобіжник зміни ключа підпису при непереданих даних (або не останньому у черзі Z-звіті).
2.2.7.5
	- Додано кнопку "Акцмзні марки" у замовленні.
	- Перероблено механізм сканування акцизних марок і їх додавання.
2.2.8.1
	- Додано кнопку ручного введення акцизної марки.
	- Об'єднано у одну кнопки перегляду і введення акцизної марки.
2.3.1.1
	- Правка назви таблиці при зміні ключа. 
	- Змінено місце розташування баз даних пРРО. Реалізовано перенесення при старті.
2.5.1.1
	- Канал зв'язку з ДФС створюється одноразово на весь час роботи пРРО.
2.5.2.1
	- Додано запис у журнал подій Syrve інформації про сканування акцизної марки.
2.5.3.3
	- Додано запис у журнал подій Syrve інформації про друк акцизної марки (чи помилку друку). 
	- Додано умову зміни ключа, якщо ключ не дійсний його можна замінити при непереданих даних. 
2.5.3.4
	- Дрібна правка виведення імені марки яка була друкована у журналі подій Syrve.
2.5.5.1
	- Правки системи архівування Z-звітів.
	- Зміни конфігурації завантаження runtime бібліотек.
	- Відправка CRMID на сервер ліцензування у запиті обміну.
	- Зменшено час першого виклику таймеру бекапу Z-звітів до 30 секунд після запуску програми.
	- Час виклику передачі Z-звіту на сервер після закриття каси скорочено до 0,5 секунди.
2.5.5.2
	- Зміни вибору конфігурації по типу збірки.
2.5.5.3
	- Зміни при перевірці даних ключа.
2.5.5.5
	- Додано варыант отримання офлайн ід без перевірки цифрового підпису при помилці недійсного сертифікату ДФС.
	- Додано логування.
2.5.5.6
	- Додано обробку помилки "Сертифікат не знайдено" при отриманні офлайн ід.
2.5.5.8
	- Зміни у масштабуванні Конфігуратора.
2.5.5.10
	- Зміни у шаблоні чеку у виведенні назви податку (назва замість "ПДВ").
	- Зміни при генерації qr, додано параметри fn i sm (сума).
2.5.6.1
	- Додано читання і друк на чеку файлу footer.txt з папки конфігу пРРО.
2.5.6.3
	- Додано перехоплення виключень сканування акцизних марок.
2.5.6.5
	- Змінено назву податків у чеку ("Без ПДВ" чи "ПДВ" замість назви податку). 
2.5.7.1
	- Додано текстовий коментар з номером замовлення з програми на чеку і у xml документі.
2.7.1.1
	- Змінено механізм сканування акцизних марок. 
	- Доступно до сканування декілька марок до позиції.
	- Збережження марок у ExternalData IOrder.
	- Друк і запис у xml чеків даних про транзакцію. 
2.8.1.0
	- Додано зовнішній файл конфігурації. 
2.8.1.1
	- Правка, зараз ProccessExciseStumps буде завжди працювати. 
2.8.1.2
	- ProccessExciseStumps() виконується пізніше.
	- Обнулення марки і коду після виконання ProccessExciseStumps у певни ситуаціях.
2.8.1.3
	- Додано заокруглення у метод getRoundQuantity(), актуально для величезних значень кількості з дробом. 
2.9.1.1
	- Додано друк копії чеку.
2.9.1.2
	- Клас розширення для парсингу даних безготівкогового платежу винесено у окремий проект (для паралельного використання у драйвері РРО).
2.9.1.5
	- Новий механізм сканування виведений у реліз.
2.9.1.6
	- Додано логування ід ключа при підписі.
2.9.1.8
	- Додано перевірку на не рівність нулю номеру замовлення при створені xml і шаблону друку чеку.
2.9.1.9
	- Додано перевірку наявності копії марки у замовленні.
2.9.1.10
	- Розширено можливість парсера даних платежу з інтеграції банк терміналу (назва платіжної системи, код авторизації, банк ід, ід терміналу).
2.9.1.15
	- Додано обробку виключень при реєстрації кастомного заокруглення. Обробка помилки старту у випадку коли встановлено сторонній плагін заокруглення.
	- У налаштування додано як параметр тип податкового ідентфікатора.
	- Додано підтягування назви типу оплати з розділу "Типи оплат і регістри" у налаштування пРРО.
2.9.1.16
	- Відключено заокруглення через API Syrve.
2.9.1.17
	- Підтягування типу ПН у XML.
2.9.1.19
	- Багфікс імовірного null значення PnTypeName при оновленні плагіна. У createRQ в т.ч.
2.9.1.20
	- Дрібна правка для виведення коду авторизації платежа у інтеграції з терміналами Ощадбанку.
2.9.1.21
	- Додано логування при друці копії чеку.
2.9.1.25
	- Правки у десеріалізації xml чеків, і зміни у шаблоні копій чеку.
2.9.1.26
	- Правки у парсері даних банківських терміналів.
2.9.1.27
	- Час зберігання чеків збільшено до 90 днів.
2.9.1.28
	- Прибрано попередження про проедоплату.
2.9.1.29
	- Bugfix при перевірці RRN у чеку
2.9.1.30 
	- Додано парсинг даних транзакції для інтеграції з МТБ банком.
2.9.2.1
	- Додано обробку помилки ErrorNotOpenShift при повторному закритті каси
2.9.2.2
	- У копії чеку виправлено друк часу з поточної дати на дату оплати.
2.9.2.8
	- При запуску з некоректним (пустим і тд) ФН пристрій буде доступний до редагування чи видалення (раніше після перезапуску фронта він зависав як невідомий).
	- При (пере)налаштуванні в обладнанні та з не коректною ліцензією статус пристрою буде мінятись на зупинений.
	- Правки вв методах Setup() i Start().
	- Правки оновлення статусу пРРО після успішної передачі даних.
	- Змінено тип виключення яке викидається при зміні ключа.
	- У методі Setup() додано перехоплення виключень при запуску DocumentHandler з зупинкою пРРО і повторним throw.
2.9.2.9
	- Додано перевірку статусу каси (на додачу до перевірки документів у черзі) при зміні ключа. 
2.9.3.1
	- Жорсткіші критерії парсингу акцизок.
	- Додано парсинг акцизок із назви страви (з плагіна РРО)
	- Додано час чеку у посилання в QR чеку.
2.9.3.3
	- Додав кнопку маосового друку Z-звітів
2.9.5.1
	- Оновлено SQLite DLL
2.9.5.2
	- Додано конфіг для включення і виключення функціоналу сканування акцизних марок.
2.9.5.5
	- Змінено механізм додавання акцизних марок у замовленні. 
2.9.6.1
	- Додано можливість міняти підпис вендора пРРО у чеку. Опція у конфігу VendorSign.
	- Додана опція вибору варіанту сканування акцизних марок, по замовчуванню марки будуть відображатись у назві страви.
	- Доданий графічний інтерфейс перегляду сканованих марок.
2.9.7.1
	- Правки виводу акцизок у UI, тепер виводить окремим рядком кожну подію сканування, тобто кожен продаж окремий рядок з номером чеку, сканування без продажу теж буде відображатись. Якщо продаж був то буде просто заповнена клітинка у' відповідній колонці.  
	- Візуальні правки UI: макс розміру вікна по висоті, заборонено тягати колонки і рядки, правка формату дати і часу і тд. 
	- Правка запису марки при вхідному скануванні і уже існуючій марці у бд.
	- Правки запису акцизки у коментар, вони будуть там дублюватись.
	- У рішення додано програму для юніт тестування (не входить у збірку). 
	- Змінено префікс перед марками у коментарях до страв. 
2.9.7.3
	- При скануванні акцизки зберігається попередній довільний коментар до страви.
	- При скануванні акцизки і виводі переліку страв для вибору включено фільтр на відбраження тільки страв які не видалені.
2.9.7.4
	- Додано пошук типу видалення страви по назві "Сканування акцизної марки у замовлення",
	для видалення віддрукованих страв при скануванні акцизки.
2.9.7.5
	- Правка шаблону коментаря з акцизкою
2.9.7.6
	- У збірці оновив кореневий сертифікат ДПІ
2.9.7.8
	- Додано обробку ситуацій коли була дата у майбутньому і сервер ДПІ не приймає таких документів. Обробка виключення ErrorXmlDateException.
2.9.8.1
	- Додано UI додавання накладних приходу з акцизними марками.
	- Змінено текст-коментар видалення страви при додаванні акцизної марки: було "Призначення акцизної марки", стало "Сканування акцизної марки у замовлення"
2.9.8.3
	- Додано кнопку виклику екранної клавіатури.
	- Правки повторного другу страви після додавання акцизної марки в замовлення на старій версії програми. Зміни у друці на всіх версіях.
2.9.8.4
	- Правка додавання акцизної марки до страви з обовязковим модифікатором. 
2.9.8.7
	- Оновлений файл стандартних податків.
	- Правка ззапису стандартного файлу податків. 
	- Автозаміна спецтегів <np> i \r\n у ФОП і "Адресі закладу" на перенесення рядка у паперовому чеку.
2.9.8.10
	- Додано штрихкод у таблицю акцизок і його обробку.
2.9.8.11
	- Правка виводу в акцизні марки випадкових записів при включеному заокруглені (коли програма додає після запису акцизок кількість порцій).
2.9.8.12
	- При помилці додавання акцизної марки до страви буде виводити текст виключення з Syrve замість шаблону.
2.9.8.13
	- Зміни у логуванні виключень при відправці Z-звітів.
2.9.8.15
	- Додано можливість масового друку копій чеків.
2.9.8.16
	- Зміни в системі заокруглення. 
2.9.8.17
	- Тимчасова правка заокруглення
2.9.8.18
	- Правка видалення акцизки з замовлення по старій схемі зберігання акцизок.
2.9.8.19
	- Правка масового друку чеків, коректність діапазону дат. 
2.9.8.20
	- Повернуто старий варіант FakeStatus. 
2.9.8.21
	- Для видаленої страви марка не буде відображатись через кнопку перегляду акцизних марок у замовленні.
2.9.8.21
	- Тимчасова правка заокруглення
2.9.8.24
	- Прибрано очищення таблиці закритих чеків.
	- Правка перевірки коду УКТЗЕД при генерації XML чеку
	- Правка QR, змінено послідовність параметрів URL і додано туди хесуму чеку (mac).
2.9.8.25
	- "Номер чеку" змінено на "ЧЕК №"
	- Дату і час зміщено на рядок нижче напису "ЧЕК №".
	- Змінено формат друку контрольного числа, на чеку і звітах, з вилучень/внесень прибрано.
	- Інші зміни чеку
	- Зміни у десеріалізаторі XML (для друку копій чеків), коректна обробка двох і більше акцизних марок до страви.  
2.9.8.27
	- Додано locker для пінгу на час закриття чеку. 
2.9.8.28
	- Додано умову щоб пінг був не в процесі при запуску таймера звязку з ДПІ з касових операцій.  
2.9.8.30
	- Правки закриття касової зміни. Генерація виключення при помилці роботи з бд.
2.9.8.32
	- Оновлено EF i SQLite до збірки 119.
2.9.9.5
	- Повернуто стару бібліотеку SQLite
	- Додано блокування з інших потоків запису/читання у бд під час закриття чеків/каси.
	- Оптимізація багатопоточності.
2.9.9.10
	- Правка послідовності друку паперової зетки і очищення таблиці продаж. 
	- Зміна запису ід типів оплат при оплаті.
	- Зміна нумерації виведення ід типу безготівкових оплат у чек.
2.9.9.15
	- Додано можливість збереження xml файлів чеків і звітів
2.9.9.17
	- У фейковому статусі не повертає суми в памяті
2.9.9.18
	- Прибрано рядок касира на чеку.
2.9.9.20
	- Додано валюту операції у рядок 18 (біля суми)
2.9.9.22
	- У статусах після чеку не повертає сум в памяті фр
2.9.9.23
	- Додано валюту операції у рядок решти
	- Додано валюту операції у рядок СУМА (20 рядок)
	- СУМА відтепер у великому регістрі
	- Перенесено податки вище: на рядок 21-22 (після "Сума")
	- Решту перенесено на 25 рядок, додано валюту
	- ПЛАТІЖНА СИСТЕМА перенесено нижче (рядок 17).
	- КОД ТРАНЗ, код авторизації у низ на рядок 17
	- ЕПЗ перенесено нижче рядок, на 16 рядок
	- Перейменовано і перенесена на 15 рядок Вид операції
	- Комісія перенесено нижче на рядок 14, додано валюту
	- Ідентифікатор платіжного пристрою на рядок 13
	- Еквайер перейменовано рядок 12
2.9.9.24
	- Додано валюту у рядки 20 і 18
2.9.10.2
	- Зміни у заокругленні на чеку і XML
2.9.10.3
	- Зміна у методі парсингу рядка ЕПЗ
2.9.10.5
	- Правки у регулярних виразах парсера ЕПЗ і коду авторизації.  
2.9.10.6
	- У фіскальний статус повернуто суму у памяті, окрмі оплати чеку
2.9.10.7
	- Правка парсингу ЕПЗ для Expirenza
2.10.1.1
	- Адаптація шаблону копії чеків під нову форму чеку
	- Додано регістри оплати
2.10.1.2
	- Правка методу пошуку RRN у чеку банк терміналу. 
2.10.1.3
	- Додано запис часу до параметрів ключа у результат підпису.
2.10.1.4
	- Правка формату назви файлів при записі чеків у папку бекапу. 
2.10.1.5
	- Додано декілька регістрів оплати
2.10.1.7
	- Додано попередження про повтор акцизної марки.
2.10.1.8
	- Оновлено бібліотеку SQLite
2.10.1.9
	- Змінено час у попереджені про термін дії ключа.
	- Правка старого варіанту сканування марки. 
2.10.1.11
	- Перевірка DiscountSum замість Discount при генерації паперового чеку.
	- При DirectIo вертаємо тепер XDocument у статусі для нових версій 
2.10.2.1
	- Додано облік заокруглень у рамках каси і відображення у х/z-звітах. 
2.10.2.2
	- Додано регістр олпати Glovo
2.10.2.3
	- Змінено ContainRRN() + Contains("RRN") замінено
2.10.3.1
	- Змінено логіку доступу до бд через обгортку у більшості методів.
	- Додано логування помилок бекап клієнта. 
2.10.3.3
	- Замість прямого доступу до бд доступ через обгортку у класах бекапу, xmlcreator
2.10.3.5
	- Оновлено CAs.json
	- Додано StampRepeatWarning і StampRepeatBan у конфіг і привязано їх до перевірки чи існувала уже акизна марка. 
2.10.3.7
	- Додано ігнорування спецсимволів у xml (для страв і назвів типів оплат) при формуванні документу.
	- Додано обробник для помилки ErrorXml. Перевірка на спецсимоли у xml і їх видалення.
2.10.3.8
	- Додано запис заокруглення безготівки в xml. 
2.10.3.12
	- Додано колонку PaymentName у таблицю Rounds і механізми роботи з нею та апгрейду бд при існуючому записі.
	- Додано запис назви типу оплати для заокруглень.
	- Додано заокруглення до друкованих звітів.
	- Додано дані про заокруглення у модель xml модель звіту для друку копій звітів. 
2.10.3.14
	- Додано цикл логування вкладених виключень у ініціалізаторі бібліотеки підпису. 
2.10.3.15
	- Додано парсинг не підписаних даних від ДПІ при отриманні списку офлайн ід але не доступності сервера для перевірки сертифікату підпису цих даних
2.10.3.16
	- Додано оновлення ід останнього чеку після кожного чеку. 
2.10.3.17
	- Правка тегів шапки звітів
2.11.1.1
	- Правки обробки виключень EDS_Handler.
	- Масштабні правки під нову версію SDK і налаштування конфігурацій збирання для двох версій. 
	- Перехід на API v8. 
2.12.1.3
	- Зміни логіки проведення пінгів. Використання задачі в окремому потоці замість асинхронного таймера. 
	- Вирішення проблеми Ping already in process.
2.12.1.4
	- Додано targetss і автоархівацію збірок релізів 
2.12.1.7
	- У prro_config.json додано опціональний boolean параметр "LargeOrderNumber", якщо додати його і виставити true
	номер замовлення на чеку буде великим шрифтом.
	- Правка механізму пінгу. Додано задачу гарантування завершення пінгу і передачі даних. 
2.12.1.8
	- Додано підтримку літери Ї у акцизних марках.
2.12.1.9
	- Правка автоматизації збірки, повернуто папку pRRO у архів релізу.
